// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.5.1
// - protoc             v4.25.6
// source: job.proto

package gen

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	emptypb "google.golang.org/protobuf/types/known/emptypb"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.64.0 or later.
const _ = grpc.SupportPackageIsVersion9

const (
	Jobs_GetLogsStreaming_FullMethodName                = "/martiancloud.phobos.api.job.Jobs/GetLogsStreaming"
	Jobs_WriteLogs_FullMethodName                       = "/martiancloud.phobos.api.job.Jobs/WriteLogs"
	Jobs_ClaimJob_FullMethodName                        = "/martiancloud.phobos.api.job.Jobs/ClaimJob"
	Jobs_GetJob_FullMethodName                          = "/martiancloud.phobos.api.job.Jobs/GetJob"
	Jobs_SetJobStatus_FullMethodName                    = "/martiancloud.phobos.api.job.Jobs/SetJobStatus"
	Jobs_SubscribeToJobCancellationEvent_FullMethodName = "/martiancloud.phobos.api.job.Jobs/SubscribeToJobCancellationEvent"
	Jobs_CancelJob_FullMethodName                       = "/martiancloud.phobos.api.job.Jobs/CancelJob"
)

// JobsClient is the client API for Jobs service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
//
// Jobs implements all functionality related to a Phobos Job.
type JobsClient interface {
	// GetLogsStreaming streams logs from a job.
	GetLogsStreaming(ctx context.Context, in *GetLogsStreamingRequest, opts ...grpc.CallOption) (grpc.ServerStreamingClient[GetLogsStreamingResponse], error)
	// WriteLogs writes a chunk of logs to the job's log stream.
	WriteLogs(ctx context.Context, in *WriteLogsRequest, opts ...grpc.CallOption) (*emptypb.Empty, error)
	ClaimJob(ctx context.Context, in *ClaimJobRequest, opts ...grpc.CallOption) (*ClaimJobResponse, error)
	// GetJob retrieves a job by ID.
	GetJob(ctx context.Context, in *GetJobInput, opts ...grpc.CallOption) (*Job, error)
	// SetJobStatus sets the status of a job.
	SetJobStatus(ctx context.Context, in *SetJobStatusInput, opts ...grpc.CallOption) (*Job, error)
	// SubscribeToJobCancellationEvent subscribes to job cancellation events.
	SubscribeToJobCancellationEvent(ctx context.Context, in *JobCancellationEventRequest, opts ...grpc.CallOption) (grpc.ServerStreamingClient[JobCancellationEventResponse], error)
	// CancelJob cancels a job.
	CancelJob(ctx context.Context, in *CancelJobRequest, opts ...grpc.CallOption) (*emptypb.Empty, error)
}

type jobsClient struct {
	cc grpc.ClientConnInterface
}

func NewJobsClient(cc grpc.ClientConnInterface) JobsClient {
	return &jobsClient{cc}
}

func (c *jobsClient) GetLogsStreaming(ctx context.Context, in *GetLogsStreamingRequest, opts ...grpc.CallOption) (grpc.ServerStreamingClient[GetLogsStreamingResponse], error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	stream, err := c.cc.NewStream(ctx, &Jobs_ServiceDesc.Streams[0], Jobs_GetLogsStreaming_FullMethodName, cOpts...)
	if err != nil {
		return nil, err
	}
	x := &grpc.GenericClientStream[GetLogsStreamingRequest, GetLogsStreamingResponse]{ClientStream: stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

// This type alias is provided for backwards compatibility with existing code that references the prior non-generic stream type by name.
type Jobs_GetLogsStreamingClient = grpc.ServerStreamingClient[GetLogsStreamingResponse]

func (c *jobsClient) WriteLogs(ctx context.Context, in *WriteLogsRequest, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, Jobs_WriteLogs_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *jobsClient) ClaimJob(ctx context.Context, in *ClaimJobRequest, opts ...grpc.CallOption) (*ClaimJobResponse, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(ClaimJobResponse)
	err := c.cc.Invoke(ctx, Jobs_ClaimJob_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *jobsClient) GetJob(ctx context.Context, in *GetJobInput, opts ...grpc.CallOption) (*Job, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(Job)
	err := c.cc.Invoke(ctx, Jobs_GetJob_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *jobsClient) SetJobStatus(ctx context.Context, in *SetJobStatusInput, opts ...grpc.CallOption) (*Job, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(Job)
	err := c.cc.Invoke(ctx, Jobs_SetJobStatus_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *jobsClient) SubscribeToJobCancellationEvent(ctx context.Context, in *JobCancellationEventRequest, opts ...grpc.CallOption) (grpc.ServerStreamingClient[JobCancellationEventResponse], error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	stream, err := c.cc.NewStream(ctx, &Jobs_ServiceDesc.Streams[1], Jobs_SubscribeToJobCancellationEvent_FullMethodName, cOpts...)
	if err != nil {
		return nil, err
	}
	x := &grpc.GenericClientStream[JobCancellationEventRequest, JobCancellationEventResponse]{ClientStream: stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

// This type alias is provided for backwards compatibility with existing code that references the prior non-generic stream type by name.
type Jobs_SubscribeToJobCancellationEventClient = grpc.ServerStreamingClient[JobCancellationEventResponse]

func (c *jobsClient) CancelJob(ctx context.Context, in *CancelJobRequest, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, Jobs_CancelJob_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// JobsServer is the server API for Jobs service.
// All implementations must embed UnimplementedJobsServer
// for forward compatibility.
//
// Jobs implements all functionality related to a Phobos Job.
type JobsServer interface {
	// GetLogsStreaming streams logs from a job.
	GetLogsStreaming(*GetLogsStreamingRequest, grpc.ServerStreamingServer[GetLogsStreamingResponse]) error
	// WriteLogs writes a chunk of logs to the job's log stream.
	WriteLogs(context.Context, *WriteLogsRequest) (*emptypb.Empty, error)
	ClaimJob(context.Context, *ClaimJobRequest) (*ClaimJobResponse, error)
	// GetJob retrieves a job by ID.
	GetJob(context.Context, *GetJobInput) (*Job, error)
	// SetJobStatus sets the status of a job.
	SetJobStatus(context.Context, *SetJobStatusInput) (*Job, error)
	// SubscribeToJobCancellationEvent subscribes to job cancellation events.
	SubscribeToJobCancellationEvent(*JobCancellationEventRequest, grpc.ServerStreamingServer[JobCancellationEventResponse]) error
	// CancelJob cancels a job.
	CancelJob(context.Context, *CancelJobRequest) (*emptypb.Empty, error)
	mustEmbedUnimplementedJobsServer()
}

// UnimplementedJobsServer must be embedded to have
// forward compatible implementations.
//
// NOTE: this should be embedded by value instead of pointer to avoid a nil
// pointer dereference when methods are called.
type UnimplementedJobsServer struct{}

func (UnimplementedJobsServer) GetLogsStreaming(*GetLogsStreamingRequest, grpc.ServerStreamingServer[GetLogsStreamingResponse]) error {
	return status.Errorf(codes.Unimplemented, "method GetLogsStreaming not implemented")
}
func (UnimplementedJobsServer) WriteLogs(context.Context, *WriteLogsRequest) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method WriteLogs not implemented")
}
func (UnimplementedJobsServer) ClaimJob(context.Context, *ClaimJobRequest) (*ClaimJobResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ClaimJob not implemented")
}
func (UnimplementedJobsServer) GetJob(context.Context, *GetJobInput) (*Job, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetJob not implemented")
}
func (UnimplementedJobsServer) SetJobStatus(context.Context, *SetJobStatusInput) (*Job, error) {
	return nil, status.Errorf(codes.Unimplemented, "method SetJobStatus not implemented")
}
func (UnimplementedJobsServer) SubscribeToJobCancellationEvent(*JobCancellationEventRequest, grpc.ServerStreamingServer[JobCancellationEventResponse]) error {
	return status.Errorf(codes.Unimplemented, "method SubscribeToJobCancellationEvent not implemented")
}
func (UnimplementedJobsServer) CancelJob(context.Context, *CancelJobRequest) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CancelJob not implemented")
}
func (UnimplementedJobsServer) mustEmbedUnimplementedJobsServer() {}
func (UnimplementedJobsServer) testEmbeddedByValue()              {}

// UnsafeJobsServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to JobsServer will
// result in compilation errors.
type UnsafeJobsServer interface {
	mustEmbedUnimplementedJobsServer()
}

func RegisterJobsServer(s grpc.ServiceRegistrar, srv JobsServer) {
	// If the following call pancis, it indicates UnimplementedJobsServer was
	// embedded by pointer and is nil.  This will cause panics if an
	// unimplemented method is ever invoked, so we test this at initialization
	// time to prevent it from happening at runtime later due to I/O.
	if t, ok := srv.(interface{ testEmbeddedByValue() }); ok {
		t.testEmbeddedByValue()
	}
	s.RegisterService(&Jobs_ServiceDesc, srv)
}

func _Jobs_GetLogsStreaming_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(GetLogsStreamingRequest)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(JobsServer).GetLogsStreaming(m, &grpc.GenericServerStream[GetLogsStreamingRequest, GetLogsStreamingResponse]{ServerStream: stream})
}

// This type alias is provided for backwards compatibility with existing code that references the prior non-generic stream type by name.
type Jobs_GetLogsStreamingServer = grpc.ServerStreamingServer[GetLogsStreamingResponse]

func _Jobs_WriteLogs_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(WriteLogsRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(JobsServer).WriteLogs(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Jobs_WriteLogs_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(JobsServer).WriteLogs(ctx, req.(*WriteLogsRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Jobs_ClaimJob_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ClaimJobRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(JobsServer).ClaimJob(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Jobs_ClaimJob_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(JobsServer).ClaimJob(ctx, req.(*ClaimJobRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Jobs_GetJob_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetJobInput)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(JobsServer).GetJob(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Jobs_GetJob_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(JobsServer).GetJob(ctx, req.(*GetJobInput))
	}
	return interceptor(ctx, in, info, handler)
}

func _Jobs_SetJobStatus_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(SetJobStatusInput)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(JobsServer).SetJobStatus(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Jobs_SetJobStatus_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(JobsServer).SetJobStatus(ctx, req.(*SetJobStatusInput))
	}
	return interceptor(ctx, in, info, handler)
}

func _Jobs_SubscribeToJobCancellationEvent_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(JobCancellationEventRequest)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(JobsServer).SubscribeToJobCancellationEvent(m, &grpc.GenericServerStream[JobCancellationEventRequest, JobCancellationEventResponse]{ServerStream: stream})
}

// This type alias is provided for backwards compatibility with existing code that references the prior non-generic stream type by name.
type Jobs_SubscribeToJobCancellationEventServer = grpc.ServerStreamingServer[JobCancellationEventResponse]

func _Jobs_CancelJob_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CancelJobRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(JobsServer).CancelJob(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Jobs_CancelJob_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(JobsServer).CancelJob(ctx, req.(*CancelJobRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// Jobs_ServiceDesc is the grpc.ServiceDesc for Jobs service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Jobs_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "martiancloud.phobos.api.job.Jobs",
	HandlerType: (*JobsServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "WriteLogs",
			Handler:    _Jobs_WriteLogs_Handler,
		},
		{
			MethodName: "ClaimJob",
			Handler:    _Jobs_ClaimJob_Handler,
		},
		{
			MethodName: "GetJob",
			Handler:    _Jobs_GetJob_Handler,
		},
		{
			MethodName: "SetJobStatus",
			Handler:    _Jobs_SetJobStatus_Handler,
		},
		{
			MethodName: "CancelJob",
			Handler:    _Jobs_CancelJob_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "GetLogsStreaming",
			Handler:       _Jobs_GetLogsStreaming_Handler,
			ServerStreams: true,
		},
		{
			StreamName:    "SubscribeToJobCancellationEvent",
			Handler:       _Jobs_SubscribeToJobCancellationEvent_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "job.proto",
}
